C   02/07/86 607061109  MEMBER NAME  DZWW     (WWMC)        FORTRAN77
C-----------------------------------------------------------------------
C
C   MONTE CARLO FOR WW PRODUCTION FROM E+E-
C   THESE SUBROUTINES HAVE BEEN EXTENSIVELY CHECKED
C                        FOUND TO BE O.K ON
C       MATRWW                 2.7.86
C       MATRZZ                 2.7.86
C       SC3                    2.7.86
C       BOOST                 28.6.85
C       SPATVC                 MAY 86
C       CHIOM                 JUNE 86
C       DIRESM                 2.7.86
C       VDECAY                 3.7.86
C       INIT                   4.7.86
C       WWXS                   4.7.86
C       ZZXS                   4.7.86
C
C----------------------------------------------------------------------
! Born xsection for Z-pair production and decay from the MC program 
! of R. Kleiss and D. Zeppenfeld.
! Adapted for YFSZZ by: B.F.L. Ward and W. Placzek
! Last update: 21.11.1996      by: WP
!======================================================================
      FUNCTION BORNV(SVARI,COSTHE)
      IMPLICIT REAL*8 (A-H,O-Y), COMPLEX*16 (Z)
      INTEGER FINDEX(4)
C     REAL*8 R(8)
      COMPLEX*16 XK(2), XL(2), G1(2), F4(2), F5(2), F6(2), F7(2)
      COMMON /BWW1/ XK,XL,F4,F5,F6,F7,G1
      COMMON /BINIT/ ALFAI,FINDEX
      COMMON /BCONST/ ECM,S,XMXWGT,NEVT
      COMMON /BPOL/ PLP,PLM,PTP,PTM,SHATP(2),SHATM(2),ZPOLPM(2,2)
      COMMON /KOPLIN/ ALFA,SIN2W,ALFAS,XMZ,XMW,XMT
      COMMON /KOPLUT/ V(4,5),A(4,5),B(5,5,5),XM2(5),XMG(5),CLR(4,5,2)
      COMMON /INFORP/CCW,WCC,PHHI,R(8)
      COMMON /IFORP/CCWW
!   --Anomalous ZZV Couplings from FILEXP
      COMMON / AnccZZ / g4(2),g5(2)
      COMPLEX*16 g4,g5
      COMMON / KeyOth / KeyCor,KeyDZ1,KeyDZ2,KeyAcc
      DATA Icall /0/
C
      IF (WCC.EQ.0d0) GOTO 999
      Icall = Icall + 1
C  Initialize parameters
      ECM = DSQRT(SVARI)
CWW   ALFAI = 128.5
      ALFAI=1D0/ALFA
CWW   ALFAS = 0.0
CWW   XMZ = 92.
CWW   XMW = 80.8
CWW   XMT = 187.5
      CCWW= COSTHE
      CCW=CCWW
      IF (Icall.GT.1) GoTo 888
C
C  Choose weighted or unweighted events by setting maximum weight.
C  If XMXWGT < 0 weighted events are calculated
      XMXWGT = -10.4
C
C  Choose WW-photon and WWZ anomalous couplings
!WPC   Photon couplings
!WP      G1(1)=(1.0,0.0)
!WP      XK(1)=(1.0,0.0)
!WP      XL(1)=(0.0,0.0)
!WP      F4(1)=(0.0,0.0)
!WP      F5(1)=(0.0,0.0)
!WP      F6(1)=(0.0,0.0)
!WP      F7(1)=(0.0,0.0)
!WPC   Z boson couplings
!WP      G1(2)=(1.0,0.0)
!WP      XK(2)=(1.0,0.0)
!WP      XL(2)=(0.0,0.0)
!WP      F4(2)=(0.0,0.0)
!WP      F5(2)=(0.0,0.0)
!WP      F6(2)=(0.0,0.0)
!WP      F7(2)=(0.0,0.0)
!WP: ZZV couplings from paremeters setup in routine FILEXP
C   Photon couplings
      G1(1)=0d0
      XK(1)=0d0
      XL(1)=0d0
      F4(1)=g4(1)
      F5(1)=g5(1)
      F6(1)=0d0
      F7(1)=0d0
C   Z boson couplings
      G1(2)=0d0
      XK(2)=0d0
      XL(2)=0d0
      F4(2)=g4(2)
      F5(2)=g5(2)
      F6(2)=0d0
      F7(2)=0d0
C
C  Choose polarization of beams (PT**2 + PL**2 < 1 required)
C   longitudinal polarization ( P=positron, M=electron)
C            PL > 0  :  righthanded polarisation
C            PL < 0  :  lefthanded polarisation
      PLP = 0.0
      PLM = 0.0
C  transverse polarization; e- beam is assumed in positive z-direction,
C   SHATP/M give the polarization direction in x-y plane
      PTP = 0.0
      SHATP(1) = 0.
      SHATP(2) = -1.
      PTM = 0.0
      SHATM(1) = 0.
      SHATM(2) = 1.
C
C  Choose final state flavors
C  The fermion indices are two digit numbers
C  the first digit is  1: neutrino of electron (muon,tau)
C                      2: electron (muon,tau)
C                      3: up quark (charm,top)
C                      4: down quark (strange,bottom)
C  the second digit is the generation index
C                      1: electron family
C                      2: muon family
C                      3: tau family
C
C  V1 decay products  ( e.g. W-  -->  F1 + F2-bar )
!WP      FINDEX(1) = 21
!WP      FINDEX(2) = 21
      CALL ZdeInd(KeyDZ1,Ind1,Ind2)
      FINDEX(1) = Ind1
      FINDEX(2) = Ind2      
C
C  V2 decay products  ( e.g. W+  -->  F3 + F4-bar )
!WP      FINDEX(3) = 22
!WP      FINDEX(4) = 22
      CALL ZdeInd(KeyDZ2,Ind3,Ind4)
      FINDEX(3) = Ind3
      FINDEX(4) = Ind4

      NEVT = 1
C
 888  CONTINUE
      CALL INIT
C     CALL OUTPT2
C     STOP
C     BORNSS=WCC
 999  CONTINUE
!WP: For ZZ xsection in fb
      BORNV = WCC *1d3 
      END
C
      SUBROUTINE ZdeInd(IdChan,Ind1,Ind2)
*     ***********************************
! Calculate indexes for Z decay products (Ind1,Ind2) for a given 
! decay channel IdChan. 
! Written by: Wieslaw Placzek         Knoxville, July 1996
! Last update: 21.11.1996       by: WP
      IMPLICIT REAL*8 (A-H,O-Z)
!
      IF (IdChan.eq.1) THEN 
        Ind1 = 11
        Ind2 = 11
      ELSEIF (IdChan.eq.2) THEN
        Ind1 = 12
        Ind2 = 12
      ELSEIF (IdChan.eq.3) THEN
        Ind1 = 13
        Ind2 = 13
      ELSEIF (IdChan.eq.4) THEN
        Ind1 = 21
        Ind2 = 21
      ELSEIF (IdChan.eq.5) THEN
        Ind1 = 22
        Ind2 = 22
      ELSEIF (IdChan.eq.6) THEN
        Ind1 = 23
        Ind2 = 23
      ELSEIF (IdChan.eq.7) THEN
        Ind1 = 31
        Ind2 = 31
      ELSEIF (IdChan.eq.8) THEN
        Ind1 = 41
        Ind2 = 41
      ELSEIF (IdChan.eq.9) THEN
        Ind1 = 32
        Ind2 = 32
      ELSEIF (IdChan.eq.10) THEN
        Ind1 = 42
        Ind2 = 42
      ELSEIF (IdChan.eq.11) THEN
        Ind1 = 43
        Ind2 = 43
      ELSE 
        Ind1 = 21
        Ind2 = 21
      ENDIF
      END
C
C----------------------------------------------------------------------
C
      BLOCK DATA
      IMPLICIT REAL*8 (A-H,O-Y), COMPLEX*16 (Z)
      REAL*4 RDM,RM1,RM2
      LOGICAL SWPAR, SWEECM, SWACRT, SWWGT
      INTEGER FL(6), GEN(6)
      CHARACTER*9 FLTEXT(4,3)
      COMMON /SWITCH/ SWPAR, SWEECM, SWACRT, SWWGT
      DATA SWPAR /.FALSE./, SWEECM /.TRUE./, SWACRT /.FALSE./
      COMMON /FLINFO/ FL, GEN, XFM(4,3), FLTEXT
      DATA XFM /12*0D0/
      DATA FLTEXT /'NU-E ','ELECTRON ','UP','DOWN',
     *         'NU-MU ','MUON ','CHARM ','STRANGE ',
     *         'NU-TAU ','TAU ','TOP ','BOTTOM'/
C     REAL*4 RDM,RM1,RM2
      COMMON/RANDM/RDM(31),RM1,RM2,IA1,IC1,M1,IX1,IA2,IC2,M2,IX2,
     *       IA3,IC3,M3,IX3
      DATA IA1,IC1,M1 /1279,351762,1664557/
      DATA IA2,IC2,M2 /2011,221592,1048583/
      DATA IA3,IC3,M3 /15091,6171,29201/
      COMMON /PARTIS/ XXS(12)
      DATA XXS /12*1D0/
      END
C
C----------------------------------------------------------------------
C
      SUBROUTINE INIT
      IMPLICIT REAL*8 (A-H,O-Y), COMPLEX*16 (Z)
      INTEGER FINDEX(3:6), FL(6), GEN(6)
      COMPLEX*16 XK(2), XL(2), G1(2), F4(2), F5(2), F6(2), F7(2),
     *           FVW(2,7), CHIS(2,2,6)
      REAL*8 OM(2,6)
C     REAL*8 OM(2,6),R(8)
C
C  Meaning of switches:
C   SWPAR  : .TRUE.  there are parity violating ZWW or AWW couplings
C   SWEECM : .TRUE.  all momenta are given in the e+e- center of mass
C                    frame
C   SWACRT : .TRUE.  the ZWW and AWW couplings are set to their new
C                    values in INIT  and MATRWW. SWACRT is reset to
C                    .FALSE. afterwards
C   SWWGT  : .TRUE.  weighted events are calculated. For unweighted
C                    events XMXWGT has to be set to the maximum weight
      LOGICAL SWPAR, SWEECM, SWACRT, SWWGT
      CHARACTER*9 FLTEXT(4,3)
      COMMON /BWW1/ XK,XL,F4,F5,F6,F7,G1
      COMMON /BINIT/ ALFAI,FINDEX
      COMMON /BCONST/ ECM,S,XMXWGT,NEVT
      COMMON /BPOL/ PLP,PLM,PTP,PTM,SHATP(2),SHATM(2),ZPOLPM(2,2)
      COMMON /KOPLIN/ ALFA,SIN2W,ALFAS,XMZ,XMW,XMT
      COMMON /KOPLUT/ V(4,5),A(4,5),B(5,5,5),XM2(5),XMG(5),CLR(4,5,2)
      COMMON /ANCOPL/ FVW
      COMMON /FLINFO/ FL, GEN, XFM(4,3), FLTEXT
      COMMON /MOMENT/ PKF(5,6)
      COMMON /BCHIOM/ CHIS, OM
      COMMON /SWITCH/ SWPAR, SWEECM, SWACRT, SWWGT
      COMMON /INFORP/CCW,WCC,PHHI,R(8)
!WP: From YFSWW
      COMMON / DECDAT / AMAFIN(20), BR(20), ICOD(20)
      DATA Icall /0/
C
      Icall = Icall + 1
C  Set rest of  input parameters
CWW   ALFA = 1D0/ALFAI
CWW   SIN2W = 1D0 - (XMW/XMZ)**2
      S = ECM**2
      CALL BORNOX(S,XMZ,XMW,SIN2W,ALFA)
CWW   CALL KOPPEL
      ENTRY INIT1
C  Initialize anomalous WW-photon and WWZ couplings
      PARCHC = 0.
      DO 10 I = 1,2
        FVW(I,1) = G1(I) + ECM**2*XL(I)/(2D0*XM2(3))
        FVW(I,2) = XL(I)
        FVW(I,3) = G1(I) + XK(I) + XL(I)
        FVW(I,4) = F4(I)
        FVW(I,5) = F5(I)
        FVW(I,6) = F6(I)
        FVW(I,7) = F7(I)
        PARCHC = PARCHC + ABS(FVW(I,5))+ABS(FVW(I,6))+ABS(FVW(I,7))
  10  CONTINUE
C     PRINT 1000, ((J,FVW(I,J),I=1,2),J=1,7)
      IF (PARCHC.GE.1D-5) THEN
        SWPAR = .TRUE.
C       PRINT 1001
      ELSE
        SWPAR = .FALSE.
C       PRINT 1002
      ENDIF
 1000 FORMAT(//' A-WW AND Z-WW ANOMALOUS COUPLINGS: ',/,
     * 7(' F-AWW(',I1,')= ',2F6.3,' F-ZWW(',I1,')= ',2F6.3,/))
 1001 FORMAT (' PARITY SWITCH ON. ( THERE ARE PARITY VIOLATING ',
     *  'VWW-COUPLINGS.) ',/)
 1002 FORMAT( ' PARITY SWITCH OFF ',/)
      IF (SWACRT) RETURN
C
      IF (Icall.GT.1) GoTo 888
C  Initialize the polarization matrix
      DENP = SHATP(1)**2 + SHATP(2)**2
      DENM = SHATM(1)**2 + SHATM(2)**2
      IF (DENP*DENM.LE.1D-10) THEN
        ZPHASP = (0D0,0D0)
        ZPHASM = (0D0,0D0)
        ZPHASE = (0D0,0D0)
      ELSE
        ZPHASP = DCMPLX(SHATP(1),SHATP(2)) / SQRT(DENP)
        ZPHASM = DCMPLX(SHATM(1),SHATM(2)) / SQRT(DENM)
        ZPHASE = -ZPHASP*ZPHASM
      ENDIF
      ZPOLPM(1,1) = (1.-PLM)*(1.+PLP)/4.
      ZPOLPM(2,1) = PTP*PTM*ZPHASE/4.
      ZPOLPM(1,2) = PTP*PTM*DCONJG(ZPHASE)/4.
      ZPOLPM(2,2) = (1.+PLM)*(1.-PLP)/4.
C     PRINT 1003,' POSITRON ',PLP*100.,PTP*100.,ZPHASP,0D0,
C    *           ' ELECTRON ',PLM*100.,PTM*100.,ZPHASM,0D0,
C    *           ((ZPOLPM(L1,L1P),L1P=1,2),L1=1,2)
 1003 FORMAT(/' INFORMATION ON BEAM POLARIZATION: '//,2(A10,'BEAM: '/
     * ' LONGITUDINAL POLARIZATION: ',F7.1,' %.'/
     * ' TRANSVERSE POLARIZATION:   ',F7.1,' % IN DIRECTION ',3F7.3//),
     * ' RESULTING POLARIZATION MATRIX: '//
     * 2(5(' '),2F8.3,5(' '),2F8.3//)     /)
C
C  Decide on weighted or unweighted events
      SWWGT = XMXWGT.LE.0.
C     IF(SWWGT) THEN
C       PRINT 1008, ' WEIGHTED ',XMXWGT
C     ELSE
C       PRINT 1008, ' UNWEIGHTED ',XMXWGT
C     ENDIF
 1008 FORMAT(/A12,'EVENTS ARE CALCULATED. THE MAXIMUM WEIGHT IS',
     * F10.3/)
C
C  Initialize fermion masses:
!WP      XFM(2,1) = 0.511D-3
!WP      XFM(2,2) = 0.10565932D0
!WP      XFM(2,3) = 1.7842D0
!WP      XFM(3,1) = 0.3D0
!WP      XFM(3,2) = 1.5D0
!WP      XFM(3,3) = XMT
!WP      XFM(4,1) = 0.3D0
!WP      XFM(4,2) = 0.5D0
!WP      XFM(4,3) = 5.0D0
!WP:fermion masses as set up in routine FILEXP
      XFM(2,1) = AMAFIN(11)
      XFM(2,2) = AMAFIN(13)
      XFM(2,3) = AMAFIN(15)
      XFM(3,1) = AMAFIN( 2)
      XFM(3,2) = AMAFIN( 4)
      XFM(3,3) = AMAFIN( 6)
      XFM(4,1) = AMAFIN( 1)
      XFM(4,2) = AMAFIN( 3)
      XFM(4,3) = AMAFIN( 5)
C     PRINT 1004, XFM
 1004 FORMAT(/' FERMION MASSES (ROW = NEUTRINO, ELECTRON, UP, DOWN;',
     * ' COLUMN = ELECTRON, MUON, TAU GENERATION) '//
     * 3(4F12.6,' GEV '/)  /)
C
 888  CONTINUE
C  Initialize beam particles
      ENTRY INIT2
      FL(1) = 2
      FL(2) = 2
      GEN(1) = 1
      GEN(2) = 1
      DO 30 I = 1,4
        DO 30 J = 1,6
          PKF(I,J) = 0D0
  30  CONTINUE
      PKF(5,1) = XFM(2,1)
      PKF(4,1) = ECM/2D0
      PKF(3,1) = SQRT(PKF(4,1)**2 - PKF(5,1)**2)
      PKF(5,2) = PKF(5,1)
      PKF(4,2) = PKF(4,1)
      PKF(3,2) = -PKF(3,1)
      SWEECM = .TRUE.
      CALL CHIOM(PKF(1,1),CHIS(1,2,1),CHIS(1,1,1),OM(1,1))
      CALL CHIOM(PKF(1,2),CHIS(1,2,2),CHIS(1,1,2),OM(1,2))
C
C  Identify final state flavors
      ENTRY INIT3
      DO 40 I = 3,6
        FL(I) = FINDEX(I)/10
        GEN(I) = FINDEX(I) - 10*FL(I)
  40  CONTINUE
      DO 50 I = 1,6
        PKF(5,I) = XFM(FL(I),GEN(I))
  50  CONTINUE
      NCR1 = FINDEX(3) - FINDEX(4)
      NCR2 = FINDEX(6) - FINDEX(5)
      IF (NCR1.EQ.0.AND.NCR2.EQ.0) THEN
        NVB = 2
C       PRINT 1005, ECM, (FLTEXT(FL(I),GEN(I)),I=3,6)
      ELSEIF (NCR1.EQ.10.AND.NCR2.EQ.10) THEN
        NVB = 3
C       PRINT 1006, ECM, (FLTEXT(FL(I),GEN(I)),I=3,6)
      ELSE
C       PRINT 1007,(FLTEXT(FL(I),GEN(I)),I=3,6)
        RETURN
      ENDIF
 1005 FORMAT(/' E-E+ --> Z0 Z0 PRODUCTION AT  ECM= ',F9.1,' GEV IS ',
     * 'CONSIDERED WITH SUBSEQUENT DECAY '/
     * 2(8(1H ),'Z0   --->  ',A9,'  PLUS  ANTI-',A9/)  /)
 1006 FORMAT(/' E-E+ --> W- W+ PRODUCTION AT  ECM= ',F9.1,' GEV IS ',
     * 'CONSIDERED WITH SUBSEQUENT DECAY '/
     * 8(1H ),'W-   --->  ',A9,'  PLUS  ANTI-',A9/
     * 8(1H ),'W+   --->  ',A9,'  PLUS  ANTI-',A9// )
 1007 FORMAT(/' E-E+ --> V1 V2 PRODUCTION ',
     * 'WITH SUBSEQUENT DECAY '/
     * 8(1H ),'V1   --->  ',A9,'  PLUS  ANTI-',A9/
     * 8(1H ),'V2   --->  ',A9,'  PLUS  ANTI-',A9/
     * ' IS NOT IMPLEMENTED YET. '//)
C     CALL OUTPUT
C     CALL RANDA(8,R,-1)
      IF (SWWGT) THEN
        IMAX = NEVT
      ELSE
        IMAX = NEVT*100
        IACC = 0
      ENDIF
      DO 60 N = 1,IMAX
        IF (NVB.EQ.2) THEN
          CALL ZZXS(R,W)
        ELSEIF(NVB.EQ.3) THEN
          CALL WWXS(R,W)
        ENDIF
      WCC=W
C     WRITE(6,*)'THE WEIGHT=',W
C       IF (SWWGT) THEN
C         CALL OUTPT1(W)
C       ELSE
C         CALL RANDA(8,R,12)
C         IF (W.GE.XMXWGT*R(5)) THEN
C           IACC = IACC + 1
C           CALL OUTPT1(1D0)
C           IF (IACC.GE.NEVT) RETURN
C         ENDIF
C       ENDIF
C       IF (MOD(N,1000).EQ.0) THEN
C         PRINT* , ' I HAVE NOW PROCESSED ',N,' EVENTS.'
C         IF (.NOT.SWWGT) PRINT* , IACC,' OF THEM ARE ACCEPTED.'
C       ENDIF
  60  CONTINUE
      RETURN
      END
C
C-------------------------------------------------------------------
C
      SUBROUTINE OUTPUT
      IMPLICIT REAL*8 (A-H,O-Y), COMPLEX*16 (Z)
      DIMENSION XXS(12),YY(12,7)
      REAL*8 Q1(4), Q2(4), QYDIR(4)
      COMMON /MOMENT/ PK1(5),PK2(5),P1(5),P2(5),P3(5),P4(5)
      COMMON /BCONST/ ECM,S,XMXWGT,NEVT
      COMMON /PARTIS/ XXS
      SAVE ACCEPW,W0SUM,W1SUM,W2SUM,YY,TPI
      DATA YY/84*0.D0/
C     SAVE ACCEPW,W0SUM,W1SUM,W2SUM,YY,TPI
C
C  INITIALIZE BOOKKEEPING
C     SAVE ACCEPW,W0SUM,W1SUM,W2SUM,YY,TPI
      PI = 4.*DATAN(1.D0)
      TPI = 2.*PI
C
C START THE INTEGRATION STEP
      ACCEPW=0.
      ACCEPZ=0.
      W0SUM=0.
      W1SUM=0.
      W2SUM=0.
      NCALL = 0
      RETURN
C
C  COLLECT EVENTS
      ENTRY OUTPT1(W)
      NCALL = NCALL + 1
C
C DEFINE THE CROSS SECTION
      IF(W.NE.0D0) ACCEPW=ACCEPW+1.
      CROSS=W
C
C DO THE INTEGRATION BOOKKEEPING
      W0SUM=W0SUM+1.
      W1SUM=W1SUM+CROSS
      W2SUM=W2SUM+CROSS**2
      DO 90 J=1,12
      YY(J,1)=YY(J,1)+1.
      YY(J,2)=YY(J,2)+XXS(J)
      YY(J,3)=YY(J,3)+XXS(J)**2
      IF(DABS(XXS(J)).GT.DABS(YY(J,6))) THEN
        YY(J,6)=XXS(J)
      ENDIF
   90 CONTINUE
C
C DO SOME ANALYSIS
C
C INVARIANT MASSES OF THE POSSIBLE JET PAIRS.
C     CALL WMASS(W,S,P1,P2,P3,P4)
C     CALL WMASS(W,S,P1,P3,P2,P4)
C     CALL WMASS(W,S,P1,P4,P2,P3)
C
C AZIMUTHAL ANGLE DISTRIBUTIONS
      DO 100 I = 1,4
        Q1(I) = P1(I) + P2(I)
        Q2(I) = P3(I) + P4(I)
        QYDIR(I) = 0.
  100 CONTINUE
      QYDIR(2) = 1.
      PHIW = AZIM(Q1,PK1,QYDIR) + 5.*TPI
      PHIL = AZIM(P1,Q1,PK1)
      PHILB = AZIM(P4,Q1,PK1)
      XH4 = DMOD(2.*PHIW + PHIL,TPI)
      XH5 = DMOD(2.*PHIW - PHIL,TPI)
      XH6 = DMOD(2.*PHIW + 2.*PHIL,TPI)
      XH7 = DMOD(2.*PHIW - 2.*PHIL,TPI)
      XH8 = DMOD(2.*PHIW +PHIL,TPI)
      XH9 = DMOD(2.*PHIW +PHILB,TPI)
      XH10 =DMOD(2.*PHIW -PHILB,TPI)
C
      RETURN
C
C ANALYSE THE RESULTS AND PRINT THEM OUT
      ENTRY OUTPT2
      SIGEST=W1SUM/W0SUM
      ERREST=DSQRT(W2SUM-W1SUM**2/W0SUM)/W0SUM
C     PRINT 200,NEVT,ACCEPW,ACCEPZ,W0SUM,W1SUM,W2SUM,SIGEST,ERREST
  200 FORMAT('0AND NOW .... THE FINAL RESULT !!!'/,
     . ' REQUESTED NUMBER OF TRIALS ',I8/,
     . ' NUMBER OF VALID W EVENTS   ',F10.1/,
     . ' NUMBER OF VALID Z EVENTS   ',F10.1/,
     . ' TOTAL NUMBER OF EVENTS     ',F10.1/,
     . ' TOTAL WEIGHT               ',D15.6/,
     . ' TOTAL WEIGHT SQUARED       ',D15.6/,
     . ' THE CROSS SECTION IS:',F12.6,' +- ',F12.6,' PB')
C
C ANALYSIS OF THE PARTIAL CONTRIBUTIONS
      DO 1002 J=1,12
      IF(YY(J,1).EQ.0.D0) GOTO 1002
      YY(J,4)=YY(J,2)/YY(J,1)
      YY(J,5)=DSQRT(YY(J,3)-YY(J,2)**2/YY(J,1))/YY(J,1)
      YY(J,7)=YY(J,4)/YY(J,6)
 1002 CONTINUE
C     PRINT 1003,(J,(YY(J,K),K=1,7),J=1,12)
 1003 FORMAT(' ANALYSIS OF THE PARTIAL CONTRIBUTIONS:'/,
     . ' THE COLUMS CONTAIN'/,11X,
     . ' # ENTRIES, TOTAL W, TOTAL W**2, MEAN W, W ERROR, MAX W',
     . ', EFFICIENCY'/,12(' ',I10,F10.1,6D10.3/))
      RETURN
      END
C
C---------------------------------------------------------------------
C
      SUBROUTINE WWXS(R,W)
      IMPLICIT REAL*8 (A-H,O-Y), COMPLEX*16 (Z)
      REAL*8 Q1(5), Q2(5), R(8), OM(2,6)
      COMPLEX*16 CHIS(2,2,6), JWMDEC(4), JWPDEC(4), AM(2),
     *           AMPROD(2,2)
      LOGICAL HELWMD, HELWPD, HEL
      COMMON /BPOL/ PLP,PLM,PTP,PTM,SHATP(2),SHATM(2),ZPOLPM(2,2)
      COMMON /KOPLUT/ V(4,5),A(4,5),B(5,5,5),XM2(5),XMG(5),CLR(4,5,2)
      COMMON /MOMENT/ PK1(5),PK2(5),P1(5),P2(5),P3(5),P4(5)
      COMMON /BCHIOM/ CHIS, OM
      COMMON /PARTIS/ X1,X2,X3, XREST(9)
C
C  Generate a phase space event
      CALL DIRESM(R,XM2(3),XMG(3),1,W,PK1,PK2,Q1,Q2,P1,P2,P3,P4)
C
C  Check whether to accept it
      X1 = 0.
      X2 = 1.
      X3 = 1.
      IF (W.EQ.0D0) RETURN
C
C  Initialize spinors
      CALL CHIOM(P1,CHIS(1,2,3),CHIS(1,1,3),OM(1,3))
      CALL CHIOM(P2,CHIS(1,2,4),CHIS(1,1,4),OM(1,4))
      CALL CHIOM(P3,CHIS(1,2,5),CHIS(1,1,5),OM(1,5))
      CALL CHIOM(P4,CHIS(1,2,6),CHIS(1,1,6),OM(1,6))
C
C  Calculate propagators
      PRWMI2 = (Q1(5)-XM2(3))**2 + XMG(3)**2* Q1(5)/XM2(3)
      PRWPI2 = (Q2(5)-XM2(4))**2 + XMG(4)**2* Q2(5)/XM2(4)
      PRPROD = 1./(PRWMI2*PRWPI2)
C  Perform polarization sum
      DO 10 L1 = 1,2
        DO 10 L1STR = 1,2
  10      AMPROD(L1,L1STR) = (0D0,0D0)
      DO 20 L3 = 1,2
      DO 20 L4 = 1,2
        DO 30 L5 = 1,2
        DO 30 L6 = 1,2
C
C  Calculate amplitudes for W- and W+ decay
          CALL VDECAY(3,3,4,L3,L4,JWMDEC,HELWMD)
          IF (HELWMD) THEN
            CALL VDECAY(4,5,6,L5,L6,JWPDEC,HELWPD)
            HEL = HELWMD.AND.HELWPD
            IF (HEL) THEN
              ZJQ1 = JWMDEC(4)*Q1(4)
              ZJQ2 = JWPDEC(4)*Q2(4)
              DO 40 I = 1,3
                ZJQ1 = ZJQ1 - JWMDEC(I)*Q1(I)
                ZJQ2 = ZJQ2 - JWPDEC(I)*Q2(I)
  40          CONTINUE
              ZJQ1 = ZJQ1/XM2(3)
              ZJQ2 = ZJQ2/XM2(4)
              DO 50 I = 1,4
                JWMDEC(I) = JWMDEC(I) - ZJQ1*Q1(I)
                JWPDEC(I) = JWPDEC(I) - ZJQ2*Q2(I)
  50          CONTINUE
              CALL MATRWW(PK1,PK2,Q1,JWMDEC,Q2,JWPDEC,AM)
              DO 60 L1 = 1,2
              DO 60 L1STR = 1,2
                AMPROD(L1,L1STR) = AMPROD(L1,L1STR) +
     *             DCONJG( AM(L1) ) * AM(L1STR)
  60          CONTINUE
            ENDIF
          ENDIF
  30    CONTINUE
  20  CONTINUE
      DO 70 L1 = 1,2
      DO 70 L1STR = 1,2
        AMPROD(L1,L1STR) = AMPROD(L1,L1STR) * PRPROD
        X1 = X1 + DREAL( AMPROD(L1,L1STR)*ZPOLPM(L1,L1STR) )
  70  CONTINUE
      X1 = X1*W
      W=X1
      RETURN
      END
C
C-------------------------------------------------------------------
      SUBROUTINE ZZXS(R,W)
      IMPLICIT REAL*8 (A-H,O-Y), COMPLEX*16 (Z)
      REAL*8 Q1(5), Q2(5), R(8), OM(2,6)
      COMPLEX*16 CHIS(2,2,6), JZ1DEC(4), JZ2DEC(4), AM(2),
     *           AMPROD(2,2)
      LOGICAL HELZ1D, HELZ2D, HEL
      COMMON /BPOL/ PLP,PLM,PTP,PTM,SHATP(2),SHATM(2),ZPOLPM(2,2)
      COMMON /KOPLUT/ V(4,5),A(4,5),B(5,5,5),XM2(5),XMG(5),CLR(4,5,2)
      COMMON /MOMENT/ PK1(5),PK2(5),P1(5),P2(5),P3(5),P4(5)
      COMMON /BCHIOM/ CHIS, OM
      COMMON /PARTIS/ XREST(3), X1, X2, X3, X4, X5, X6, X7, X8, X9
C
C  Generate a phase space event
      CALL DIRESM(R,XM2(2),XMG(2),2,W,PK1,PK2,Q1,Q2,P1,P2,P3,P4)
C
C  Check whether to accept it
      X1 = 0.
      X2 = 1.
      X3 = 1.
      IF (W.EQ.0D0) RETURN
C
C  Initialize spinors
      CALL CHIOM(P1,CHIS(1,2,3),CHIS(1,1,3),OM(1,3))
      CALL CHIOM(P2,CHIS(1,2,4),CHIS(1,1,4),OM(1,4))
      CALL CHIOM(P3,CHIS(1,2,5),CHIS(1,1,5),OM(1,5))
      CALL CHIOM(P4,CHIS(1,2,6),CHIS(1,1,6),OM(1,6))
C
C  Calculate propagators
      PRZ1I2 = (Q1(5)-XM2(2))**2 + XMG(2)**2 * Q1(5)/XM2(2)
      PRZ2I2 = (Q2(5)-XM2(2))**2 + XMG(2)**2 * Q2(5)/XM2(2)
      PRPROD = 1./(PRZ1I2*PRZ2I2)
C  Perform polarization sum
      DO 10 L1 = 1,2
        DO 10 L1STR = 1,2
  10      AMPROD(L1,L1STR) = (0D0,0D0)
      DO 20 L3 = 1,2
      DO 20 L4 = 1,2
        DO 30 L5 = 1,2
        DO 30 L6 = 1,2
C
C  Calculate amplitudes for first and second Z decay
          CALL VDECAY(2,3,4,L3,L4,JZ1DEC,HELZ1D)
          IF (HELZ1D) THEN
            CALL VDECAY(2,5,6,L5,L6,JZ2DEC,HELZ2D)
            HEL = HELZ1D.AND.HELZ2D
            IF (HEL) THEN
              ZJQ1 = JZ1DEC(4)*Q1(4)
              ZJQ2 = JZ2DEC(4)*Q2(4)
              DO 40 I = 1,3
                ZJQ1 = ZJQ1 - JZ1DEC(I)*Q1(I)
                ZJQ2 = ZJQ2 - JZ2DEC(I)*Q2(I)
  40          CONTINUE
              ZJQ1 = ZJQ1/XM2(2)
              ZJQ2 = ZJQ2/XM2(2)
              DO 50 I = 1,4
                JZ1DEC(I) = JZ1DEC(I) - ZJQ1*Q1(I)
                JZ2DEC(I) = JZ2DEC(I) - ZJQ2*Q2(I)
  50          CONTINUE
              CALL MATRZZ(PK1,PK2,Q1,JZ1DEC,Q2,JZ2DEC,AM)
              DO 60 L1 = 1,2
              DO 60 L1STR = 1,2
                AMPROD(L1,L1STR) = AMPROD(L1,L1STR) +
     *             DCONJG( AM(L1) ) * AM(L1STR)
  60          CONTINUE
            ENDIF
          ENDIF
  30    CONTINUE
  20  CONTINUE
      DO 70 L1 = 1,2
      DO 70 L1STR = 1,2
        AMPROD(L1,L1STR) = AMPROD(L1,L1STR) * PRPROD
        X1 = X1 + DREAL( AMPROD(L1,L1STR)*ZPOLPM(L1,L1STR) )
  70  CONTINUE
      X1 = X1*W
      W = X1
      RETURN
      END
C
C----------------------------------------------------------------------
C
      SUBROUTINE VDECAY(NVB,NF1,NF2,L1,L2,ZRES,HELIC)
C
C  VDECAY calculates the four-vector M-nu in the decay amplitude
C  M = M-nu * eps-nu of  V --> F1 + F2-bar decay for fixed F1 and
C  F2 helicities L1 and L2
C
      IMPLICIT REAL*8 (A-H,O-Y), COMPLEX*16 (Z)
      PARAMETER ( WURZ3=1.73205080757D0, ONE=1D0 )
      COMPLEX*16 ZRES(4), CHIS(2,2,6)
      REAL*8 OM(2,6)
      INTEGER FL(6), GEN(6)
      CHARACTER*9 FLTEXT(4,3)
      LOGICAL HELIC
      COMMON /FLINFO/ FL, GEN, XFM(4,3), FLTEXT
cc      COMMON /FLINFO/ FL, GEN
      COMMON /KOPLUT/ V(4,5),A(4,5),B(5,5,5),XM2(5),XMG(5),CLR(4,5,2)
      COMMON /BCHIOM/ CHIS, OM
      DO 1 I = 1,4
        ZRES(I) = (0D0,0D0)
  1   CONTINUE
      HELIC = .FALSE.
      IF (FL(NF1).GE.3) THEN
        IF (GEN(NF1).LE.2.AND.GEN(NF2).LE.2) THEN
          IF (L1.EQ.L2) RETURN
          IF (L1.EQ.2.AND.NVB.NE.2) RETURN
        ENDIF
        COF = WURZ3*(3.-2.*L2)
      ELSE
        IF (L1.EQ.L2) RETURN
        IF (L1.EQ.2.AND.NVB.NE.2) RETURN
        COF = ONE*(3.-2.*L2)
      ENDIF
C
      OMFAC = COF*CLR(FL(NF1),NVB,1)*OM(3-L1,NF1)*OM(L2,NF2)
      IF (NVB.EQ.2) THEN
        OMFAC4 = COF*CLR(FL(NF1),NVB,2)*OM(L1,NF1)*OM(3-L2,NF2)
        OMFACI =  OMFAC + OMFAC4
        OMFAC4 = -OMFAC + OMFAC4
      ELSE
        OMFACI =  OMFAC
        OMFAC4 = -OMFAC
      ENDIF
C
      Z1 = DCONJG(CHIS(1,L1,NF1)) * CHIS(1,3-L2,NF2)
      Z2 = DCONJG(CHIS(2,L1,NF1)) * CHIS(2,3-L2,NF2)
      Z3 = DCONJG(CHIS(1,L1,NF1)) * CHIS(2,3-L2,NF2)
      Z4 = DCONJG(CHIS(2,L1,NF1)) * CHIS(1,3-L2,NF2)
      ZRES(1) = ( Z3 + Z4 ) * OMFACI
      ZRES(2) = (-Z3 + Z4 ) * OMFACI* (0D0,1D0)
      ZRES(3) = ( Z1 - Z2 ) * OMFACI
      ZRES(4) = ( Z1 + Z2 ) * OMFAC4
      HELIC = .TRUE.
      RETURN
      END
C
C----------------------------------------------------------------------
C
      SUBROUTINE MATRWW(PK1,PK2,Q1,EPS1,Q2,EPS2,AM)
C
C  MATRWW calculates the matrix element for e-e+ --> W-W+ (sum of
C  neutrino, photon and Z exchange ) for arbitrary three vector boson
C  couplings FVW using the formulas given in appendix C of
C  K.Hagiwara et al., Probing the weak boson sector in e+e- --> W+W-,
C                     DESY 86-058
C
      IMPLICIT REAL*8 (A-H,O-Y), COMPLEX*16 (Z)
      REAL*8 PK1(4), PK2(4), Q1(4), Q2(4), P(4), PNU(4), Q1MQ2(4),
     *       OM(2,6)
      COMPLEX*16 EPS1(4), EPS2(4), SP12Q(4), SP12P(4)
      COMPLEX*16 CHIE(2,2), CHIP(2,2), CHREST(16), SC1, SC3
      COMPLEX*16 GV(4), FVW(2,7), FLR(2,7), AM(2)
C
C  Meaning of switches:
C   SWPAR  : .TRUE.  there are parity violating ZWW or AWW couplings
C   SWEECM : .TRUE.  all momenta are given in the e+e- center of mass
C                    frame
C   SWACRT : .TRUE.  the ZWW and AWW couplings are set to their new
C                    values in INIT  and MATRWW. SWACRT is reset to
C                    .FALSE. afterwards
      LOGICAL SWPAR, SWEECM, SWACRT, SWWGT
      PARAMETER ( ZI=(0D0,1D0) )
      SAVE FLR, S, P, GWENOM, NCALL
      EXTERNAL SC1, SC3
C
      COMMON /KOPLUT/ V(4,5),A(4,5),B(5,5,5),XM2(5),XMG(5),CLR(4,5,2)
      COMMON /ANCOPL/ FVW
      COMMON /BCHIOM/ CHIE, CHIP, CHREST, OM
      COMMON /SWITCH/ SWPAR, SWEECM, SWACRT, SWWGT
      DATA NCALL /0/
C
C  preparation of nonchanging variables
!WP   IF (NCALL.EQ.0.OR.SWACRT) THEN
        P(4) = PK1(4) + PK2(4)
        S = P(4)**2
        DO 1 I = 1,3
          IF (SWEECM) THEN
            P(I) = 0D0
            NCALL = 1
          ELSE
            P(I) = PK1(I) + PK2(I)
            S = S - P(I)**2
          ENDIF
   1    CONTINUE
        OM1OM2 = OM(2,1)*OM(2,2)
        IF (SWACRT) THEN
          CALL INIT1
          SWACRT = .FALSE.
        ENDIF
        DO 2 I = 1,2
          DO 3 J = 1,7
            FLR(I,J) =
     *             CLR(2,1,I)*FVW(1,J)*B(3,4,1)/S +
     *             CLR(2,2,I)*FVW(2,J)*B(3,4,2)/DCMPLX(S-XM2(2),XMG(2))
   3        FLR(I,J) = FLR(I,J)*OM1OM2
          FLR(I,2) = FLR(I,2)/XM2(3)
          FLR(I,7) = FLR(I,7)/XM2(3)
          FLR(I,4) = FLR(I,4)*ZI
   2      FLR(I,5) = FLR(I,5)*ZI
        GWENOM = CLR(2,3,1)**2*OM1OM2
!WP   ENDIF
C
C  calculate the neutrino exchange graph
      PNU(4) = PK1(4) - Q1(4)
      TVAR = PNU(4)**2
      DO 10 I = 1,3
        PNU(I) = PK1(I) - Q1(I)
        TVAR = TVAR - PNU(I)**2
  10  CONTINUE
      AM(1) = GWENOM* SC3(CHIP(1,1),EPS2,PNU,EPS1,CHIE(1,1),-1) /TVAR
      AM(2) = (0D0,0D0)
C
C  prepare the calculation of the photon and Z exchange graphs
      Q1MQ2(4) = Q1(4) - Q2(4)
      ZEPS12 = EPS1(4)*EPS2(4)
      ZPEPS1 = P(4)*EPS1(4)
      ZPEPS2 = P(4)*EPS2(4)
      DO 11 I = 1,3
        Q1MQ2(I) = Q1(I) - Q2(I)
        ZEPS12 = ZEPS12 - EPS1(I)*EPS2(I)
        IF (.NOT.SWEECM) THEN
          ZPEPS1 = ZPEPS1 - P(I)*EPS1(I)
          ZPEPS2 = ZPEPS2 - P(I)*EPS2(I)
        ENDIF
  11  CONTINUE
      IF (SWPAR) THEN
        CALL SPATVC(SP12Q,EPS1,EPS2,Q1MQ2)
        CALL SPATVC(SP12P,EPS1,EPS2,P)
        ZPP12Q = P(4)*SP12Q(4)
        IF (.NOT.SWEECM) THEN
          ZPP12Q = ZPP12Q - P(1)*SP12Q(1)-P(2)*SP12Q(2)-P(3)*SP12Q(3)
        ENDIF
      ENDIF
C
C set up the "interaction vector" GAMMA-V-mu (see Hagiwara et al.)
      DO 12 L1 = 1,2
        Z1 = FLR(L1,1)*ZEPS12 - FLR(L1,2)*ZPEPS1*ZPEPS2
        IF (SWPAR) THEN
          Z1 = Z1 - FLR(L1,7)*ZPP12Q
        ENDIF
        Z2 = (FLR(L1,3) + FLR(L1,4)) * ZPEPS1
        Z3 = (-FLR(L1,3) + FLR(L1,4)) * ZPEPS2
        DO 13 I = 1,4
  13      GV(I) = Q1MQ2(I)*Z1 + EPS2(I)*Z2 + EPS1(I)*Z3
        IF (SWPAR) THEN
          DO 14 I = 1,4
  14        GV(I) = GV(I) + FLR(L1,5)*SP12Q(I) - FLR(L1,6)*SP12P(I)
        ENDIF
        LH = 2*L1-3
        AM(L1) = AM(L1) + SC1(CHIP(1,L1),GV,CHIE(1,L1),LH)
  12  CONTINUE
      RETURN
      END
C
C----------------------------------------------------------------------
C
      SUBROUTINE MATRZZ(PK1,PK2,Q1,EPS1,Q2,EPS2,AM)
! Modified by: W. Placzek -- Anomalous Couplings added!
! Knoxville, June 1996,     Last update: 22.11.1996 
C
C  MATRZZ calculates the matrix element for e-e+ --> Z Z within the
C  standard model using the formulas given in appendix D of
C  K.Hagiwara et al., Probing the weak boson sector in e+e- --> W+W-,
C                     DESY 86-058
C
      IMPLICIT REAL*8 (A-H,O-Y), COMPLEX*16 (Z)
      REAL*8 PK1(4), PK2(4), Q1(4), Q2(4), PTCH(4), PUCH(4), OM(2,6)
      COMPLEX*16 EPS1(4), EPS2(4), AM(2)
      COMPLEX*16 CHIE(2,2), CHIP(2,2), CHREST(16), SC3
      COMMON /KOPLUT/ V(4,5),A(4,5),B(5,5,5),XM2(5),XMG(5),CLR(4,5,2)
      COMMON /BCHIOM/ CHIE, CHIP, CHREST, OM
      EXTERNAL SC3
!WP---------------------------------------------------------
      REAL*8 Q1MQ2(4), P(4) 
      COMPLEX*16 GV(4), FVW(2,7), FLR(2,7)
      COMPLEX*16 SP12Q(4), SP12P(4), SC1
      LOGICAL SWPAR, SWEECM, SWACRT, SWWGT
      PARAMETER ( ZI=(0D0,1D0) )
      SAVE FLR, S, P, GWENOM, NCALL
      EXTERNAL SC1
C
      COMMON /ANCOPL/ FVW
      COMMON /SWITCH/ SWPAR, SWEECM, SWACRT, SWWGT
      DATA NCALL /0/
C
C  preparation of nonchanging variables
!WP   IF (NCALL.EQ.0.OR.SWACRT) THEN
        P(4) = PK1(4) + PK2(4)
        S = P(4)**2
        DO 21 I = 1,3
          IF (SWEECM) THEN
            P(I) = 0D0
            NCALL = 1
          ELSE
            P(I) = PK1(I) + PK2(I)
            S = S - P(I)**2
          ENDIF
  21    CONTINUE
        OM1OM2 = OM(2,1)*OM(2,2)
        IF (SWACRT) THEN
          CALL INIT1
          SWACRT = .FALSE.
        ENDIF
        DO 22 I = 1,2
          DO 23 J = 1,7
!WP: Modified WW version
            FLR(I,J) =
     *             CLR(2,1,I)*FVW(1,J)*B(3,1,4)/XM2(2) +
     *             CLR(2,2,I)*FVW(2,J)*B(3,1,4)/XM2(2)
 23         FLR(I,J) = FLR(I,J)*OM1OM2
          FLR(I,2) = FLR(I,2)/XM2(3)
          FLR(I,7) = FLR(I,7)/XM2(3)
          FLR(I,4) = FLR(I,4)*ZI
 22       FLR(I,5) = FLR(I,5)*ZI
        GWENOM = CLR(2,3,1)**2*OM1OM2
!WP   ENDIF
!WP---------------------------------------------------------
C
C  calculate the t- and u-channel graphs
      PTCH(4) = PK1(4) - Q1(4)
      PUCH(4) = Q1(4) - PK2(4)
      TVAR = PTCH(4)**2
      UVAR = PUCH(4)**2
      DO 1 I = 1,3
        PTCH(I) = PK1(I) - Q1(I)
        TVAR = TVAR - PTCH(I)**2
        PUCH(I) = PK1(I) - Q2(I)
        UVAR = UVAR - PUCH(I)**2
  1   CONTINUE
      DO 2 L1 = 1,2
        LH = 2*L1 - 3
        AM(L1) = SC3(CHIP(1,L1),EPS2,PTCH,EPS1,CHIE(1,L1),LH)/TVAR
        AM(L1) = SC3(CHIP(1,L1),EPS1,PUCH,EPS2,CHIE(1,L1),LH)/UVAR
     *         + AM(L1)
        AM(L1) = CLR(2,2,L1)**2 * OM(2,1)*OM(2,2) * AM(L1)
  2   CONTINUE
!WP---------------------------------------------------------
C
C  prepare the calculation of the photon and Z exchange graphs
      Q1MQ2(4) = Q1(4) - Q2(4)
      ZEPS12 = EPS1(4)*EPS2(4)
      ZPEPS1 = P(4)*EPS1(4)
      ZPEPS2 = P(4)*EPS2(4)
      DO 11 I = 1,3
        Q1MQ2(I) = Q1(I) - Q2(I)
        ZEPS12 = ZEPS12 - EPS1(I)*EPS2(I)
        IF (.NOT.SWEECM) THEN
          ZPEPS1 = ZPEPS1 - P(I)*EPS1(I)
          ZPEPS2 = ZPEPS2 - P(I)*EPS2(I)
        ENDIF
  11  CONTINUE
      IF (SWPAR) THEN
        CALL SPATVC(SP12Q,EPS1,EPS2,Q1MQ2)
        CALL SPATVC(SP12P,EPS1,EPS2,P)
        ZPP12Q = P(4)*SP12Q(4)
        IF (.NOT.SWEECM) THEN
          ZPP12Q = ZPP12Q - P(1)*SP12Q(1)-P(2)*SP12Q(2)-P(3)*SP12Q(3)
        ENDIF
      ENDIF
C
C set up the "interaction vector" GAMMA-V-mu (see Hagiwara et al.)
      DO 12 L1 = 1,2
        Z1 = FLR(L1,1)*ZEPS12 - FLR(L1,2)*ZPEPS1*ZPEPS2
        IF (SWPAR) THEN
          Z1 = Z1 - FLR(L1,7)*ZPP12Q
        ENDIF
        Z2 = (FLR(L1,3) + FLR(L1,4)) * ZPEPS1
        Z3 = (-FLR(L1,3) + FLR(L1,4)) * ZPEPS2
        DO 13 I = 1,4
 13        GV(I) = Q1MQ2(I)*Z1 + EPS2(I)*Z2 + EPS1(I)*Z3
        IF (SWPAR) THEN
          DO 14 I = 1,4
 14          GV(I) = GV(I) + FLR(L1,5)*SP12Q(I) - FLR(L1,6)*SP12P(I)
        ENDIF
        LH = 2*L1-3
        AM(L1) = AM(L1) + SC1(CHIP(1,L1),GV,CHIE(1,L1),LH)
  12  CONTINUE
!WP---------------------------------------------------------
      RETURN
      END
C
      SUBROUTINE MATRZ0(PK1,PK2,Q1,EPS1,Q2,EPS2,AM)
C
C  MATRZZ calculates the matrix element for e-e+ --> Z Z within the
C  standard model using the formulas given in appendix D of
C  K.Hagiwara et al., Probing the weak boson sector in e+e- --> W+W-,
C                     DESY 86-058
C
      IMPLICIT REAL*8 (A-H,O-Y), COMPLEX*16 (Z)
      REAL*8 PK1(4), PK2(4), Q1(4), Q2(4), PTCH(4), PUCH(4), OM(2,6)
      COMPLEX*16 EPS1(4), EPS2(4), AM(2)
      COMPLEX*16 CHIE(2,2), CHIP(2,2), CHREST(16), SC3
      COMMON /KOPLUT/ V(4,5),A(4,5),B(5,5,5),XM2(5),XMG(5),CLR(4,5,2)
      COMMON /BCHIOM/ CHIE, CHIP, CHREST, OM
      EXTERNAL SC3
C
C  calculate the t- and u-channel graphs
      PTCH(4) = PK1(4) - Q1(4)
      PUCH(4) = Q1(4) - PK2(4)
      TVAR = PTCH(4)**2
      UVAR = PUCH(4)**2
      DO 1 I = 1,3
        PTCH(I) = PK1(I) - Q1(I)
        TVAR = TVAR - PTCH(I)**2
        PUCH(I) = PK1(I) - Q2(I)
        UVAR = UVAR - PUCH(I)**2
  1   CONTINUE
      DO 2 L1 = 1,2
        LH = 2*L1 - 3
        AM(L1) = SC3(CHIP(1,L1),EPS2,PTCH,EPS1,CHIE(1,L1),LH)/TVAR
        AM(L1) = SC3(CHIP(1,L1),EPS1,PUCH,EPS2,CHIE(1,L1),LH)/UVAR
     *         + AM(L1)
        AM(L1) = CLR(2,2,L1)**2 * OM(2,1)*OM(2,2) * AM(L1)
  2   CONTINUE
      RETURN
      END

C
C
C----------------------------------------------------------------------
C
      SUBROUTINE DIRESM(R,RM2,RMG,IP,G,PK1,PK2,Q1,Q2,P1,P2,P3,P4)
C
C  ADAPTED FROM RKWW BY R.KLEISS
C
C PHASE SPACE GENERATOR FOR THE PRODUCTION OF A PAIR
C OF RESONANCES DECAYING INTO 4 PARTICLES.
C R(8): RANDOM NUMBER ARRAY (BETWEEN 0 AND 1)
C RM2: RESONANCE MASS SQUARED
C RMG: RESONANCE TOTAL WIDTH * MASS
C IP: ANGULAR DEPENDENCE PARAMETER:
C     =1: PRODUCTION PEAKED IN FORWARD DIRECTION
C     =2:  "           "     "  " & BACKWARD  "
C G: WEIGHT OF THE PRODUCED PHASE SPACE POINT (GE.0)
C PK1,PK2: THE MOMENTA OF THE INCOMING PARTICLES
C Q1,Q2:         "   "   "  TWO RESONANCES
C P1,..,P4:      "   "   "  OUTGOING PARTICLES
C THE FOURTH COMPONENT OF THE MOMENTA IS THE TIME COMPONENT
C THE FIFTH COMPONENT CONTAINS THE MASS EXCEPT FOR Q1 AND Q2 WHERE
C THE MASS**2 IS STORED
C
      IMPLICIT REAL*8(A-H,O-Z)
      REAL*8 R(8), PK1(5), PK2(5), Q1(5), Q2(5),
     *       P1(5), P2(5), P3(5), P4(5), H(4)
      COMMON / INFOR / XM1,XM2,C,D
      COMMON /IFORP/CCWW
C     DATA INIT/0/
C     IF (INIT.EQ.0) THEN
C       INIT=1
C
C INITIALIZE THE OVERALL CONSTANT AND P1,P2
        PI = 4.*DATAN(1.D0)
        RS = PK1(4) + PK2(4)
        S = RS**2
        CON=1./(2.*S)
     .     *1./(2.*PI)**8
     .     *1./(8.D0)**3
     .     *1./S
     .     *4.D0
     .     *(2.*PI)**3
     .     *PI**2
     .     *3.89371D+08
C       PRINT 1,RS,CON
    1   FORMAT('0 DIRES START: ROOT(S),CON =',2D15.6)
C     ENDIF
C
C THE DEFAULT EVENT WEIGHT IS ZERO
      G=0.
C
C GENERATE THE RESONATING PAIR MASSES
      Q1(5) = RM2+RMG*DTAN((R(1)-.5)*PI)
      Q2(5) = RM2+RMG*DTAN((R(2)-.5)*PI)
C
C CHECK ON THE PHASE SPACE RESTRICTIONS
      IF(Q1(5).LT.0.D0) RETURN
      IF(Q2(5).LT.0.D0) RETURN
      XM1=DSQRT(Q1(5))
      XM2=DSQRT(Q2(5))
      IF((XM1+XM2).GT.RS) RETURN
      IF((P1(5)+P2(5)).GT.XM1) RETURN
      IF((P3(5)+P4(5)).GT.XM2) RETURN
C
C GENERATE THE NONTRIVIAL POLAR ANGLE (2 POSSIBILITIES)
      D = S-Q1(5)-Q2(5)
      XL = DSQRT(D**2-4.*Q1(5)*Q2(5))
      D=D/XL
      IF (IP.EQ.1) THEN
        C=D-(D+1.)*((D-1.)/(D+1.))**R(3)
      ELSEIF (IP.EQ.2) THEN
        E=((D+1.)/(D-1.))**(2.*R(3)-1.)
        C=D*((E-1.)/(E+1.))
      ELSE
        RETURN
      ENDIF
      CPP=C
      C=CCWW
C GENERATE THE REMAINING ANGULAR VARIABLES
      F=2.*PI*R(4)
      F1=2.*PI*R(5)
      F2=2.*PI*R(6)
      C1=-1.+2.*R(7)
      C2=-1.+2.*R(8)
C
C CONSTRUCT MOMENTUM Q1 OF THE FIRST RESONANCE
      SC = SQRT(1.-C*C)
      Q1(4) = (S+Q1(5)-Q2(5))/(2.*RS)
      QV = SQRT(Q1(4)**2-Q1(5))
      Q1(3)=QV*C
      Q1(2)=QV*SC*COS(F)
      Q1(1)=QV*SC*SIN(F)
C
C CONSTRUCT P1 IN REST FRAME OF FIRST RESONANCE
      P1SQ = P1(5)**2
      P2SQ = P2(5)**2
      DEN = 1./(2.*XM1)
      H(4) = (Q1(5)+P1SQ-P2SQ)*DEN
      S1 = SQRT(1.-C1*C1)
      HV = SQRT(H(4)**2-P1SQ)
      BETA12 = 4.*HV*DEN
      H(3)=HV*C1
      H(2)=HV*S1*COS(F1)
      H(1)=HV*S1*SIN(F1)
C
C BOOST VECTOR H TO ITS LAB FRMANE VALUE P1
      CALL BOOST(H,Q1,P1)
C
C CONSTRUCT P2 FROM MOMENTUM CONSERVATION
      DO 2 I=1,4
    2 P2(I)=Q1(I)-P1(I)
C
C CONSTRUCT THE MOMENTUM OF THE SECOND RESONANCE
      Q2(4)=RS-Q1(4)
      DO 3 I=1,3
    3 Q2(I)=-Q1(I)
C
C CONSTRUCT P3 IN REST FRAME OF SECOND RESONANCE
      P3SQ = P3(5)**2
      P4SQ = P4(5)**2
      DEN = 1./(2.*XM2)
      H(4) = (Q2(5)+P3SQ-P4SQ)*DEN
      S2 = SQRT(1.-C2*C2)
      HV = SQRT(H(4)**2-P3SQ)
      BETA34 = 4.*HV*DEN
      H(3)=HV*C2
      H(2)=HV*S2*COS(F2)
      H(1)=HV*S2*SIN(F2)
C
C BOOST VECTOR H TO ITS LAB FRMANE VALUE P3
      CALL BOOST(H,Q2,P3)
C
C CONSTRUCT P4 FROM MOMENTUM CONSERVATION
      DO 4 I=1,4
    4 P4(I)=Q2(I)-P3(I)
      C=CPP
C CALCULATE THE EVENT WEIGHT (2 POSSIBILITIES)
      G=0.
      IF(IP.EQ.1) G=(D-C)*DLOG((D+1.)/(D-1.))
      IF(IP.EQ.2) G=(D*D-C*C)/D*DLOG((D+1.)/(D-1.))
      RMG2=(RMG)**2
C     G=1D0
      G=G
     . *((Q1(5)-RM2)**2+RMG2)
     . *((Q2(5)-RM2)**2+RMG2)
     . /RMG2
     . *XL
     . *BETA12*BETA34
     . *CON
C
      RETURN
      END
C
C-------------------------------------------------------------------
      SUBROUTINE BOOST(P,R,Q)
C-----------------------------------------------------------------------
C     THE FOUR VECTOR P IS ASSUMED TO BE GIVEN IN THE REST FRAME OF R,
C     WHICH MUST BE A TIMELIKE VECTOR.
C     OUTPUT Q IS THE VECTOR P BOOSTED TO THE FRAME IN WHICH R IS GIVEN.
C-------------------------------------------------COMPARE JACKSON, P.517
C----------------------------------------------D. ZEPPENFELD (28.6.1985)
C-----------------------------------------------------------------------
      IMPLICIT REAL*8 (A-H,J-Z)
      DIMENSION P(4),R(4),Q(4),BETA(3)
      X = 0D0
      Y = 0D0
      DO 10 I = 1,3
      BETA(I) = R(I)/R(4)
      X = X + BETA(I)**2
   10 Y = Y + BETA(I)*P(I)
      IF (X.LT.1D-16.OR.X.GE.(1D0-1D-12)) GOTO 30
      GAMMA = 1D0/DSQRT(1D0-X)
      DO 20 I = 1,3
   20 Q(I) = P(I)+BETA(I)*(Y*(GAMMA-1D0)/X + GAMMA*P(4))
      Q(4) = GAMMA*(P(4) + Y)
      RETURN
   30 CONTINUE
      DO 40 I = 1,4
   40 Q(I) = P(I)
      IF(X.GE.(1D0-1D-12)) WRITE(6,1000) R
      RETURN
 1000 FORMAT (' THE REFERENCE VECTOR ',4F10.3,'   IS NOT TIMELIKE.')
      END
C
C-------------------------------------------------------------------
      SUBROUTINE SPATVC(RES,A,B,C)
      IMPLICIT COMPLEX*16 (A-Z)
C
C SPATVC calculates the four vector
C   RES-mu = EPS-mu-alpha-beta-rho * A-alpha * B-beta * C-rho
C where EPS is the totally antisymmetric tensor in Bjorken-Drell
C convention
C
      REAL*8 C(4)
      COMPLEX*16 RES(4), A(4), B(4)
      BC12 = B(1)*C(2) - B(2)*C(1)
      BC23 = B(2)*C(3) - B(3)*C(2)
      BC31 = B(3)*C(1) - B(1)*C(3)
      BC41 = B(4)*C(1) - B(1)*C(4)
      BC42 = B(4)*C(2) - B(2)*C(4)
      BC43 = B(4)*C(3) - B(3)*C(4)
      RES(4) = A(1)*BC23 + A(2)*BC31 + A(3)*BC12
      RES(1) = -A(2)*BC43 + A(3)*BC42 + A(4)*BC23
      RES(2) = A(1)*BC43 + A(4)*BC31 - A(3)*BC41
      RES(3) = -A(1)*BC42 + A(2)*BC41 + A(4)*BC12
      RETURN
      END
C
C-------------------------------------------------------------------
      SUBROUTINE CHIOM(P,CHIP,CHIM,OM)
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8  P(5), OM(2)
      COMPLEX*16   CHIP(2), CHIM(2)
      PARAMETER (EPS=1E-30)
C
      PAXY = P(1)**2 + P(2)**2
      PABS = SQRT(PAXY + P(3)**2)
      PAPZ = PABS + ABS(P(3))
      IF (P(3).LT.0D0) PAPZ = PAXY/PAPZ
      IF(PAPZ.GT.EPS*PABS) THEN
           DEN = 1D0/SQRT(2D0*PABS*PAPZ)
           CHIP(1) = DEN * PAPZ
           CHIP(2) = DEN * DCMPLX( P(1), P(2) )
      ELSE
           CHIP(1) = 0D0
           CHIP(2) = 1D0
      END IF
      CHIM(1) = -DCONJG(CHIP(2))
      CHIM(2) =  CHIP(1)
      OM(2) = SQRT(P(4)+PABS)
      OM(1) = P(5)/OM(2)
      RETURN
      END
C
C-------------------------------------------------------------------
      FUNCTION SC3(CHII,A1,A2,A3,CHIF,ALPHA)
      IMPLICIT COMPLEX*16 (A-H,O-Z)
      PARAMETER ( ZI=(0D0,1D0) )
      INTEGER  ALPHA, ALP, N, NN
      COMPLEX*16  CHII(2), CHIF(2), CHIAUX(2), CHIDUM, ASLASH(2,2)
      COMPLEX*16  SC0, SC1, SC3
      COMPLEX*16  A1(4), A3(4), AUX(4,3)
      REAL*8  A2(4)
C
      N = 3
      ASSIGN 3 TO NN
      GOTO 10
C
      ENTRY SC0(CHII,CHIF,ALPHA)
      N = 0
      GOTO 20
C
      ENTRY SC1(CHII,A1,CHIF,ALPHA)
      N = 1
      ASSIGN 1 TO NN
      GOTO 10
C
 10   CONTINUE
         I = 1
         GOTO NN
  3      AUX(I,3) = A3(I)
         AUX(I,2) = A2(I)
  1      AUX(I,1) = A1(I)
         I = I + 1
         IF (I.LE.4) GOTO NN
   20 CONTINUE
      CHIAUX(1) = DCONJG(CHII(1))
      CHIAUX(2) = DCONJG(CHII(2))
      ALP = ALPHA
C
      DO 30 I = 1,N
         IF (ALP.GT.0) THEN
            ASLASH(1,1) = AUX(4,I) - AUX(3,I)
            ASLASH(1,2) = -AUX(1,I) + ZI*AUX(2,I)
            ASLASH(2,1) = -AUX(1,I) - ZI*AUX(2,I)
            ASLASH(2,2) = AUX(4,I) + AUX(3,I)
         ELSE
            ASLASH(1,1) = AUX(4,I) + AUX(3,I)
            ASLASH(1,2) = AUX(1,I) - ZI*AUX(2,I)
            ASLASH(2,1) = AUX(1,I) + ZI*AUX(2,I)
            ASLASH(2,2) = AUX(4,I) - AUX(3,I)
         ENDIF
         CHIDUM = CHIAUX(1)*ASLASH(1,1) + CHIAUX(2)*ASLASH(2,1)
         CHIAUX(2) = CHIAUX(1)*ASLASH(1,2) + CHIAUX(2)*ASLASH(2,2)
         CHIAUX(1) = CHIDUM
         ALP = - ALP
 30   CONTINUE
C
      SC3  = CHIAUX(1) * CHIF(1) + CHIAUX(2) * CHIF(2)
      RETURN
      END
C
C-----------------------------------------------------------------------
C
      SUBROUTINE BORNOX(SVAL,XMZ,XMW,S2W,ALFA)
C--------------------------------------------
C THE LOWEST-ORDER TOTAL CROSS SECTIONS FOR
C E+ E-  ---> W+ W-
C       AND
C E+ E-  ---> ZO ZO
C IN THE STANDARD MODEL, ASSUMING ZERO WIDTHS.
C
C  TAKEN FROM RKWW BY R.KLEISS
C--------------------------------------------
      IMPLICIT REAL*8(A-H,O-Z)
C
C THE CROSS SECTION FOR E+ E-  --->  ZO ZO
C SEE R.BROWN & K.MIKAELIAN, PHYS.REV.D19(1979)972
      EL=DSQRT(4.*3.1415926536*ALFA)
      SW=DSQRT(S2W)
      CW=DSQRT(1.-S2W)
      GA=-EL/4./SW/CW
      GV=GA*(1.-4.*S2W)
      SIGZZ=0.
      Z=XMZ**2/SVAL
      IF(Z.GT..25D0) GOTO 2000
      BZ=DSQRT(1.-4.*Z)
      GG=GV**4+6.*GV**2*GA**2+GA**4
      SIGZZ=3.8937D+08 * GG /(4.*3.1415927D0*XMZ**2)
     . *( (1.+4.*Z**2)/(1.-2.*Z)*DLOG((1.+BZ)/(1.-BZ))
     .    -BZ )  * Z
 2000 CONTINUE
C
C THE CROSS SECTION FOR E+ E-  --->  W+ W-
C SEE R.PHILIPPE, PHYS.REV.D26(1982)1588
      S=SVAL/XMW**2
      IF(S.LT.4.D0) GOTO 3000
      BW=DSQRT(1.-4./S)
      BT=DLOG((1.+BW)/(1.-BW))/BW
      R=XMZ**2/XMW**2
      S2=S**2
      S3=S2*S
      G1=2.*S/3.*(S3+16.*S2-68.*S-48.)
      G2=(S2+20.*S-48.)/12.
     .  +4.*(1.-2./S)*BT
      G3=-(S3+18.*S2-28.*S-24.)/3.
     .   +32.*(1.+1./(2.*S))*BT
      SAA=S2W**2/S2*G1
      V=(S2W-1./4.)/CW
      A=-1./4./CW
      SZZ=CW**2*(V**2+A**2)/(-S+R)**2*G1
      SNN=G2
      SAZ=2.*V*CW*S2W/S/(-S+R)*G1
      SAN=S2W/S*G3
      SZN=(V+A)*CW/(-S+R)*G3
      G=EL/SW
      SIGWW=3.8937D+08 * BW /(128.*3.1415927D0*XMW**2*S)
     . *G**4*(SAA+SZZ+SNN+SAZ+SAN+SZN)
C
C PRINT OUT THE RESULTS
 3000 ROOTS=DSQRT(SVAL)
C     PRINT 4000,ROOTS,XMZ,XMW,S2W,SIGZZ,SIGWW
 4000 FORMAT(' TOTAL LOWEST-ORDER CROSS SECTIONS FOR',
     . ' ZERO BOSON WIDTHS:'/,
     . ' INVARIANT MASS    =',F10.3,' GEV'/,
     . ' Z0 MASS           =',F10.3,' GEV'/,
     . ' W  MASS           =',F10.3,' GEV'/,
     . ' SIN**2 WEAK ANGLE =',F10.3/,
     . ' E+ E- ---> Z0 Z0  :',F15.6,' PB'/,
     . ' E+ E- ---> W+ W-  :',F15.6,' PB'/,
     . ' ',40(1H-))
      RETURN
      END
C
C----------------------------------------------------------------------
C
      SUBROUTINE KOPPEL
      IMPLICIT REAL*8(A-H,O-Z)
C
C  ADAPTED FROM RKWW BY R.KLEISS
C
C CALCULATE THE FERMION-FERMION-BOSON AND THREE-BOSON COUPLINGS
C IN THE STANDARD MODEL, WITHOUT COLOUR FACTORS.
C ALSO CALCULATE MASS**2 AND MASS*WIDTH OF THE BOSONS.
C V   =  FFB VECTOR COUPLING
C A   =  FFB AXIAL-VECTOR COUPLING
C CLR =  FFB LEFT- AND RIGHTHANDED COUPLINGS
C B   =  BBB COUPLING
C THE FERMION INDICES ARE:  1: NEUTRINO OF ELECTRON (MUON,TAU)
C                           2: ELECTRON (MUON,TAU)
C                           3: UP QUARK (CHARM,TOP)
C                           4: DOWN QUARK (STRANGE,BOTTOM)
C THE BOSON INDICES ARE     1: PHOTON
C                           2: Z0 BOSON
C                           3: W+ BOSON
C                           4: W- BOSON
C                           5: GLUON
C THE HELICITY INDICES ARE  1: LEFTHANDED
C                           2: RIGHTHANDED
C NO KOBAYASHI-MASKAWA MIXING IS IMPLEMENTED HERE.
C THE W+- ARE IDENTIFIED AS OUTGIONG FROM THE BBB VERTEX.
C XM2= BOSON MASS**2
C XMG= BOSON MASS*WIDTH
      COMMON / KOPLUT / V(4,5),A(4,5),B(5,5,5),XM2(5),XMG(5),CLR(4,5,2)
C THE FUNDAMENTAL PARAMETERS:
C ALFA = THE Q.E.D. FINE STRUCTURE CONSTANT
C SIN2 = SIN**2 OF THE WEAK MIXING ANGLE
C ALFAS = THE QCD FINE STRUCTURE CONSTANT
C XMZ = MASS OF THE Z0 BOSON IN GEV
C XGZ = TOTAL WIDTH OF THE Z0 BOSON IN GEV
C XMW = MASS OF THE W+- BOSONS IN GEV
C XGW = WIDTH OF THE W+- BOSONS IN GEV
      COMMON / KOPLIN / ALFA,SIN2W,ALFAS,XMZ,XMW,XMT
!WP: from YFSWW
      COMMON / WEKING / ENE,AMAZ,GAMMZ,AMEL,AMFIN,XK0,SINW2,IDE,IDF 
      COMMON / Wparam / amaW,GammW
      DATA INFO/0/
CWW   DATA IWAR/0/
C
C PHASE SPACE REDUCTION FACTOR FOR HEAVY FERMIONIC DECAYS
      HEAVY(X,Y1,Y2)=( 1. -.5*(Y1**2+Y2**2)
     . -.5*(Y1**2-Y2**2)**2 + 3.*Y1*Y2*((X**2-1.)/(X**2+1.))
     . )*DSQRT((1.-Y1**2-Y2**2)**2-4.*Y1**2*Y2**2)
C
      PI=4.*DATAN(1.D0)
      E = DSQRT(4.*PI*ALFA )
      G = DSQRT(4.*PI*ALFAS)
      S = DSQRT(SIN2W)
      C = DSQRT(1.-SIN2W)
      Z = E/4./C/S
      W = E/S/SQRT(8.)
      Q = E*C/S
C
C THE FFB VECTOR COUPLING
      V(1,1) = 0.
      V(2,1) = -E
      V(3,1) = 2.*E/3.
      V(4,1) = -E/3.
      V(1,2) =  Z
      V(2,2) = -Z*(1.-4.*SIN2W)
      V(3,2) =  Z*(1.-8./3.*SIN2W)
      V(4,2) = -Z*(1.-4./3.*SIN2W)
      DO 1 J=3,4
      DO 1 K=1,4
    1 V(K,J) = W
      V(1,5) = 0.
      V(2,5) = 0.
      V(3,5) = G
      V(4,5) = G
C
C THE FFB AXIAL-VECTOR COUPLING
      DO 2 J=1,5,4
      DO 2 K=1,4
    2 A(K,J) = 0.
      A(1,2) =  Z
      A(2,2) = -Z
      A(3,2) =  Z
      A(4,2) = -Z
      DO 3 J=3,4
      DO 3 K=1,4
    3 A(K,J) = W
C
C THE FFB LEFT- AND RIGHTHANDED COUPLINGS
      DO 4 K=1,4
      DO 4 J=1,5
      CLR(K,J,1)=V(K,J)+A(K,J)
    4 CLR(K,J,2)=V(K,J)-A(K,J)
C
C THE BBB COUPLINGS
      DO 5 I=1,5
      DO 5 J=1,5
      DO 5 K=1,5
    5 B(I,J,K) = 0.
      B(3,4,1) = -E
      B(4,1,3) = -E
      B(1,3,4) = -E
      B(1,4,3) =  E
      B(4,3,1) =  E
      B(3,1,4) =  E
      B(3,4,2) = -Q
      B(4,2,3) = -Q
      B(2,3,4) = -Q
      B(2,4,3) =  Q
      B(4,3,2) =  Q
      B(3,2,4) =  Q
      B(5,5,5) = G
C
C CALCULATE THE TOTAL DECAY WIDTHS OF THE
C HEAVY BOSONS AND THE BRANCHING RATIOS
      DECW=XMW/12./PI
      GWNE=DECW*( V(1,3)**2 + A(1,3)**2 )
      GWUD=DECW*( V(3,3)**2 + A(3,3)**2 ) *3. *(1.+ALFAS/PI)
      GWTB=0.
      IF(XMT.GT.XMW) GOTO 31
      GWTB=GWUD*HEAVY( V(3,3)/A(3,3) , XMT/XMW , 0.D0)
   31 XGW= 3.*GWNE + 2.*GWUD + GWTB
      BWNE=GWNE/XGW *100.
      BWUD=GWUD/XGW *100.
      BWTB=GWTB/XGW *100.
      DECZ=XMZ/12./PI
      GZNN=DECZ*( V(1,2)**2 + A(1,2)**2 )
      GZEE=DECZ*( V(2,2)**2 + A(2,2)**2 )
      GZUU=DECZ*( V(3,2)**2 + A(3,2)**2 ) *3. *(1.+ALFAS/PI)
      GZDD=DECZ*( V(4,2)**2 + A(4,2)**2 ) *3. *(1.+ALFAS/PI)
      GZTT=0.
      IF(XMT.GT.XMZ/2.) GOTO 32
      GZTT=GZUU*HEAVY( V(3,2)/A(3,2) , XMT/XMZ , XMT/XMZ )
   32 XGZ= 3.*GZNN + 3.*GZEE + 2.*GZUU + 3.*GZDD + GZTT
      BZNN=GZNN/XGZ *100.
      BZEE=GZEE/XGZ *100.
      BZUU=GZUU/XGZ *100.
      BZDD=GZDD/XGZ *100.
      BZTT=GZTT/XGZ *100.
!WP: W and Z widths from input parameters
      XGW = GammW
      XGZ = GammZ
C
C THE MASS AND WIDTH INFORMATION
      XM2(1) = 0.
      XM2(2) = XMZ**2
      XM2(3) = XMW**2
      XM2(4) = XM2(3)
      XM2(5) = 0.
      XMG(1) = 0.
      XMG(2) = XMZ*XGZ
      XMG(3) = XMW*XGW
      XMG(4) = XMG(3)
      XMG(5) = 0.
C
C PRINT OUT THE COUPLING CONSTANTS
      IF(INFO.GE.1) RETURN
      INFO=INFO+1
CWW
CWW   IF(IWAR.LT.1)WRITE(6,*)' GW=',XGW,' GZ=',XGZ
CWW   IWAR=IWAR+1
CWW
C     PRINT 10
   10 FORMAT('0',20(1H-),' START OF KOPPEL INFO ',20(1H-))
C     PRINT 11,1./ALFA,SIN2W,ALFAS,XMZ,XMW,XMT
   11 FORMAT('0'/,
     . ' I CALCULATE THE COUPLINGS IN THE STANDARD MODEL.'/,
     . ' THE INPUT PARAMETERS ARE :'/,
     . ' Q.E.D. FINE STRUCTURE CONSTANT  :  1/',F7.3/,
     . ' SIN**2 OF THE WEAK MIXING ANGLE :',F8.5/,
     . ' Q.C.D. FINE STRUCTURE CONSTANT  :',F8.5/,
     . ' MASS OF THE Z0 BOSON            :',F8.3,' GEV'/,
     . ' MASS OF THE W+/- BOSONS         :',F8.3,' GEV'/,
     . ' MASS OF THE TOP QUARK           :',F8.3,' GEV'/,
     . ' (ALL OTHER FERMIONS HAVE ZERO MASS)' )
C     PRINT 12,C,S,Z,W,Q
   12 FORMAT('0',/' C,S,Z,W,Q =',5F10.6)
C     PRINT 13,((V(J,K),K=1,5),J=1,4)
   13 FORMAT('0'/,
     . ' FFB VECTOR COUPLING ( ROW=F , COL= B )'/,
     . 4(5F10.6/))
C     PRINT 14,((A(J,K),K=1,5),J=1,4)
   14 FORMAT('0'/,
     . ' FFB AXIAL-VECTOR COUPLING ( ROW=F , COL= B )'/,
     . 4(5F10.6/))
C     PRINT 15,((CLR(J,K,1),K=1,5),J=1,4)
   15 FORMAT('0'/,
     . ' FFB LEFTHANDED COUPLING ( ROW=F , COL= B )'/,
     . 4(5F10.6/))
C     PRINT 16,((CLR(J,K,2),K=1,5),J=1,4)
   16 FORMAT('0'/,
     . ' FFB RIGHTHANDED COUPLING ( ROW=F , COL= B )'/,
     . 4(5F10.6/))
C     PRINT 17,(((B(I,J,K),K=1,5),J=1,5),I=1,5)
   17 FORMAT('0'/,
     . ' BBB NON-ABELIAN COUPLINGS'/,
     . 5( 5(5F10.6/)/) )
C     PRINT 18,XGW,BWNE,BWUD,BWTB,XGZ,BZNN,BZEE,BZUU,BZDD,BZTT
   18 FORMAT('0THE WIDTHS OF THE HEAVY BOSONS, AND THE WAY',
     . ' THEY ARE BUILT UP:'/,
     . ' TOTAL WIDTH OF W+ OR W-       =',F7.3,' GEV'/,
     . ' BR FOR LEPTON DECAY           =',F7.3,' %'/,
     . ' BR FOR MASSLESS QUARK DECAY   =',F7.3,' %'/,
     . ' BR FOR TOP-BOTTOM DECAY       =',F7.3,' %'/,
     . ' TOTAL WIDTH OF Z0             =',F7.3,' GEV'/,
     . ' BR FOR NEUTRINO DECAY         =',F7.3,' %'/,
     . ' BR FOR LEPTON DECAY           =',F7.3,' %'/,
     . ' BR FOR LIGHT UP DECAY         =',F7.3,' %'/,
     . ' BR FOR DOWN DECAY             =',F7.3,' %'/,
     . ' BR FOR TOP DECAY              =',F7.3,' %')
C     PRINT 19,(XM2(J),XMG(J),J=1,5)
   19 FORMAT('0'/,
     . ' MASS**2 AND MASS*WIDTH VALUES'/,5(2F10.2/))
C     PRINT 20
   20 FORMAT('0',20(1H-),' END OF KOPPEL INFO   ',20(1H-))
      RETURN
      END
C
C-----------------------------------------------------------------------
C
      SUBROUTINE RANDA(N,RAND,IDUM)
C
C   SUBROUTINE GENERATES UNIFORMLY DISTRIBUTED RANDOM NO'S X(I),I=1,N
      COMMON/RANDM/RDM(31),RM1,RM2,IA1,IC1,M1,IX1,IA2,IC2,M2,IX2,
     1       IA3,IC3,M3,IX3
      REAL*8 RAND(N),RANMAR
!WP
      REAL*8 DRVEC(N) 
      CALL VARRAN(DRVEC,N)
!
!WP      DO 1 I=1,N
!WP    1 RAND(I)=RANMAR(IDUM)
      DO I = 1,N
        RAND(I) = DRVEC(I) 
      ENDDO
      RETURN
      END
C
C
      FUNCTION AZIM(V,A,B)
      IMPLICIT REAL*8 (A-H,K-M,O-Z)
      DIMENSION V(4),A(4),B(4),VN(3),BN(3)
      EXTERNAL SPAT
C
C     AZIM CALCULATES THE AZIMUTHAL ANGLE OF VECTOR(=FIRST 3 COMP.) V
C     AROUND THE DIRECTION OF A WITH RESPECT TO THE A-B-PLANE
C
      XVA = 0D0
      XBA = 0D0
      XAA = 0D0
      DO 10 I = 1,3
      XVA = XVA + V(I)*A(I)
      XBA = XBA + B(I)*A(I)
      XAA = XAA + A(I)*A(I)
   10 CONTINUE
      FV = 0D0
      FB = 0D0
      DO 20 I = 1,3
      VN(I) = V(I) - A(I)*XVA/XAA
      BN(I) = B(I) - A(I)*XBA/XAA
      FV = FV + VN(I)**2
      FB = FB + BN(I)**2
   20 CONTINUE
      COSPHI = 0D0
      F = 1./SQRT(FV*FB)
      DO 30 I = 1,3
      COSPHI = COSPHI + VN(I)*BN(I)*F
   30 CONTINUE
      AZIM = DSIGN(DACOS(COSPHI),SPAT(V,A,B))
      RETURN
      END
C
C---------------------------------------------------------------------
C
      FUNCTION SPAT(A,B,C)
      IMPLICIT REAL*8 (A-H,K-M,O-Z)
      DIMENSION A(4),B(4),C(4)
      S = A(1)*B(2)*C(3)
      S = S + A(2)*B(3)*C(1)
      S = S + A(3)*B(1)*C(2)
      S = S - A(3)*B(2)*C(1)
      S = S - A(2)*B(1)*C(3)
      SPAT = S - A(1)*B(3)*C(2)
      RETURN
      END
